## ghdl 4.1.0+dfsg

=== testsuite/requirements.txt ===
-r ../pyGHDL/requirements.txt

pytest>=7.3.0
pytest-cov>=2.10.1

# Coverage collection
Coverage>=7.2

=== pyGHDL/cli/requirements.txt ===
-r ../dom/requirements.txt

pyTooling>=4.0.1, <5.0
pyAttributes>=2.3.2

=== pyGHDL/dom/requirements.txt ===
-r ../libghdl/requirements.txt

pyVHDLModel==0.25.1
#https://github.com/VHDL/pyVHDLModel/archive/dev.zip#pyVHDLModel

=== pyGHDL/libghdl/requirements.txt ===
pyTooling>=4.0.1, <5.0

=== pyGHDL/lsp/requirements.txt ===
-r ../libghdl/requirements.txt

=== src/edif/Makefile ===
GNATMAKE=gnatmake -j0
CFLAGS=-g
GNAT_FLAGS=-aI.. -aI../vhdl -aI../psl -aI../grt -gnat05 -gnaty3befhkmr -gnata -gnatf -gnatwae $(CFLAGS)
BE=debug
ortho_srcdir=../ortho
GEN_SRCS=edif-nodes.adb edif-nodes_meta.ads edif-nodes_meta.adb
CC=gcc

PNODES=../../scripts/pnodes.py
PNODES_ARGS=--field-file=edif-nodes.adb.in \
  --kind-file=edif-nodes.ads \
  --node-file=edif-nodes.ads \
  --template-file=edif-nodes.adb.in \
  --meta-basename=edif-nodes_meta \
  --kind-type=Nkind \
  --kind-range-prefix=Nkinds_ \
  --kind-prefix=N_ \
  --node-type=Node

all: dump_edif


dump_edif$(EXEEXT): $(GEN_SRCS) force
	$(GNATMAKE) $(GNAT_FLAGS) dump_edif

edif-nodes.adb: edif-nodes.adb.in edif-nodes.ads $(PNODES)
	$(RM) -f $@
	$(PNODES) $(PNODES_ARGS) body > $@
	chmod a-w $@

edif-nodes_meta.ads: edif-nodes_meta.ads.in edif-nodes.ads $(PNODES)
	$(RM) -f $@
	$(PNODES) $(PNODES_ARGS) meta_specs > $@
	chmod a-w $@

edif-nodes_meta.adb: edif-nodes_meta.adb.in edif-nodes.ads $(PNODES)
	$(RM) -f $@
	$(PNODES) $(PNODES_ARGS) --keep-order meta_body > $@
	chmod a-w $@

clean: force
	$(RM) -f *.o *.ali dump_edif  *.cf b~*.ad?

maintainer-clean: clean
	$(RM) -f $(GEN_SRCS)

force:

=== src/verilog/Makefile ===
PNODES=../../scripts/pnodes.py
PNODES_ARGS=--field-file=verilog-nodes.adb.in --kind-file=verilog-nodes.ads --node-file=verilog-nodes.ads --template-file=verilog-nodes.adb.in --meta-basename=verilog-nodes_meta --kind-type=Nkind --kind-range-prefix=Nkinds_ --kind-prefix=N_ --node-type=Node

all: verilog-nodes.adb verilog-nodes_meta.ads verilog-nodes_meta.adb

verilog-nodes.adb: verilog-nodes.adb.in verilog-nodes.ads $(PNODES)
	$(RM) -f $@
	$(PNODES) $(PNODES_ARGS) body > $@
	chmod a-w $@

verilog-nodes_meta.ads: verilog-nodes_meta.ads.in verilog-nodes.ads $(PNODES)
	$(RM) -f $@
	$(PNODES) $(PNODES_ARGS) meta_specs > $@
	chmod a-w $@

verilog-nodes_meta.adb: verilog-nodes_meta.adb.in verilog-nodes.ads $(PNODES)
	$(RM) -f $@
	$(PNODES) $(PNODES_ARGS) --keep-order meta_body > $@
	chmod a-w $@

=== src/ortho/oread/Makefile ===
#  -*- Makefile -*- for the ortho-code compiler.
#  Copyright (C) 2005 Tristan Gingold
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <gnu.org/licenses>.
BE = gcc
ortho_srcdir=..
BACK_END=$(ortho_srcdir)/$(BE)
ortho_exec=oread-$(BE)

all: $(ortho_exec)

test: test.s
	$(CC) -o $@ $^

test.s: $(ortho_exec)
	./$(ortho_exec) test

$(ortho_exec): force
	$(MAKE) -f $(BACK_END)/Makefile ortho_exec=$(ortho_exec)

clean:
	$(MAKE) -f $(BACK_END)/Makefile clean
	$(RM) -f oread-gcc oread-mcode *.o *~

distclean: clean
	$(MAKE) -f $(BACK_END)/Makefile distclean

force:

.PHONY: force

=== testsuite/gna/issue450/cocotb/Makefile ===
CWD = $(shell pwd)
COCOTB = $(CWD)/../../..

TOPLEVEL_LANG = vhdl

VHDL_SOURCES = $(CWD)/../hdl/top.vhd

SIM = ghdl
CMD_BIN = ghdl

TOPLEVEL=top
MODULE=$(TOPLEVEL)_cocotb

include $(COCOTB)/makefiles/Makefile.inc
include $(COCOTB)/makefiles/Makefile.sim

sim: $(MODULE).py

=== debian/changelog ===
ghdl (4.1.0+dfsg-4build1) plucky; urgency=medium

  * No-change rebuild for LLVM 20.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 20 Feb 2025 22:01:10 +0100

ghdl (4.1.0+dfsg-4) unstable; urgency=medium

  * Restrict architectures to those on which GHDL builds and clears the
    testsuite (Closes: 1081717, 1010539)
  * Fix lintian override for undefined license

 -- Andreas Bombe <aeb@debian.org>  Sun, 17 Nov 2024 11:48:24 +0100

ghdl (4.1.0+dfsg-3) unstable; urgency=medium

  * Add allow-llvm19 patch and adjust Build-Depends to allow building with
    LLVM 19 (Closes: 1085096)
  * Backport patch from upstream to fix testsuite VPI prototypes
  * Fix some testsuite file patterns in debian/copyright
  * Add lintian source override for a testsuite with a generic BSD license

 -- Andreas Bombe <aeb@debian.org>  Sat, 16 Nov 2024 14:22:08 +0100

ghdl (4.1.0+dfsg-2) unstable; urgency=medium

  * Upload to unstable
  * Add collect-gcc-options patch for proper calling of GCC backend
  * Update debian/copyright with new files, years and changed libghw license

 -- Andreas Bombe <aeb@debian.org>  Wed, 28 Aug 2024 01:21:13 +0200

ghdl (4.1.0+dfsg-1) experimental; urgency=medium

  [ Andreas Bombe ]
  * Exclude more test suites from orig tarball for 4.1.0
  * New upstream version 4.1.0+dfsg (Closes: 1067686)
  * Drop LLVM 16 support patches, version 4.1.0 supports up to 18.1
  * Allow LLVM versions up to 18.1
  * Use GCC/GNAT version 13 (Closes: 1067446)
  * Update libghdl soname to current version
  * Bump Standards-Version to 4.7.0, no changes needed
  * Add avoid-have-backtrace patch to disable use of backtrace(3) for now
  * Backport patches from upstream fixing VPI and VHPI testsuite
  * Backport patch from upstream to fix PSL counter initialization
  * Make LLVM backend testsuite failure during build fatal again
  * Adapt to the gcc-13 build installing ghdl1 under libexec instead of lib

  [ Nicolas Boulenguez ]
  * Install the usr/bin/ghdl wrapper with dh_install directly
  * Install usr/lib/ghdl/backend/vhdl/src with dh_link directly
  * Drop obsolete gcc-10 patch
  * Slightly simplify the backend selection with build profiles
  * debian/control: remove unused shlibs:Depends from ghdl-common Depends

 -- Andreas Bombe <aeb@debian.org>  Wed, 31 Jul 2024 23:23:10 +0900

=== debian/control ===
Source: ghdl
Section: electronics
Priority: optional
Maintainer: Debian Electronics Team <pkg-electronics-devel@lists.alioth.debian.org>
Uploaders: Andreas Bombe <aeb@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-ada-library (>= 8.1),
               gnat-13, gcc-13, g++-13,
               gcc-13-source <!pkg.ghdl.nogcc>,
               libisl-dev (>= 0.14) <!pkg.ghdl.nogcc>,
               libmpc-dev (>= 1.0) <!pkg.ghdl.nogcc>,
               libmpfr-dev (>= 3.0.0-9~) <!pkg.ghdl.nogcc>,
               libgmp-dev (>= 2:5.0.1~) <!pkg.ghdl.nogcc>,
               texinfo <!pkg.ghdl.nogcc>,
               llvm-dev (<< 1:20~) <!pkg.ghdl.nollvm>,
               clang (>= 1:3.5) <!pkg.ghdl.nollvm>,
               zlib1g-dev
Standards-Version: 4.7.0
Homepage: https://github.com/ghdl/ghdl
Vcs-Browser: https://salsa.debian.org/electronics-team/ghdl/ghdl
Vcs-Git: https://salsa.debian.org/electronics-team/ghdl/ghdl.git
Rules-Requires-Root: no

Package: ghdl
Architecture: amd64 arm64 armel ppc64el ppc64
Depends: ghdl-common (= ${binary:Version}),
         ghdl-mcode [amd64] <!pkg.ghdl.nomcode>
         | ghdl-gcc <!pkg.ghdl.nogcc>
         | ghdl-llvm <!pkg.ghdl.nollvm>,
         ${misc:Depends}
Suggests: gtkwave
Description: VHDL compiler/simulator
 GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
 GHDL is not an interpreter: it allows you to analyse and elaborate sources to
 generate machine code from your design. Native program execution is the only
 way for high speed simulation.
 .
 GHDL offers three machine code generation backends: one based on GCC, one
 using the LLVM compiler suite and a GHDL specific one called mcode. These are
 available in the ghdl-gcc, ghdl-llvm and ghdl-mcode packages respectively.
 Both the GCC and LLVM backends create highly optimized code for excellent
 simulation performance while simulations compiled with the GCC backend also
 allow coverage testing using gcov. The mcode backend creates less performant
 code but makes up for it with much faster compilation. It is therefore
 preferable for smaller projects without large or long running simulations.
 .
 Multiple backends can be installed at the same time and selected by either
 invoking the desired GHDL directly (as ghdl-gcc, ghdl-llvm or ghdl-mcode) or
 by providing a GHDL_BACKEND environment variable (containing gcc, llvm or
 mcode) while invoking ghdl.
 .
 This package is a dependency package that will make sure at least one backend
 is installed.

Package: ghdl-common
Architecture: amd64 arm64 armel ppc64el ppc64
Depends: ${misc:Depends}
Breaks: ghdl (<< 0.37+dfsg2)
Replaces: ghdl (<< 0.37+dfsg2)
Description: VHDL compiler/simulator (common files)
 GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
 GHDL is not an interpreter: it allows you to analyse and elaborate sources to
 generate machine code from your design. Native program execution is the only
 way for high speed simulation.
 .
 This package contains common files for the GHDL compiler packages.

Package: ghdl-mcode
Architecture: amd64
Build-Profiles: <!pkg.ghdl.nomcode>
Depends: ghdl-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: VHDL compiler/simulator (mcode backend)
 GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
 GHDL is not an interpreter: it allows you to analyse and elaborate sources to
 generate machine code from your design. Native program execution is the only
 way for high speed simulation.
 .
 This package contains the compiler with the mcode backend.

Package: ghdl-gcc
Architecture: amd64 arm64 armel ppc64el ppc64
Build-Profiles: <!pkg.ghdl.nogcc>
Built-Using: ${Built-Using-GCC}
Depends: ghdl-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
	gcc, zlib1g-dev
Description: VHDL compiler/simulator (GCC backend)
 GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
 GHDL is not an interpreter: it allows you to analyse and elaborate sources to
 generate machine code from your design. Native program execution is the only
 way for high speed simulation.
 .
 This package contains the compiler with the GCC backend.

Package: ghdl-llvm
Architecture: amd64 arm64 armel ppc64el ppc64
Build-Profiles: <!pkg.ghdl.nollvm>
Depends: ghdl-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
	gcc, zlib1g-dev
Description: VHDL compiler/simulator (LLVM backend)
 GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
 GHDL is not an interpreter: it allows you to analyse and elaborate sources to
 generate machine code from your design. Native program execution is the only
 way for high speed simulation.
 .
 This package contains the compiler with the LLVM backend.

Package: ghdl-tools
Architecture: amd64 arm64 armel ppc64el ppc64
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: gtkwave (<< 3.3.110~)
Replaces: gtkwave (<< 3.3.110~)
Description: VHDL compiler/simulator (tools)
 GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
 GHDL is not an interpreter: it allows you to analyse and elaborate sources to
 generate machine code from your design. Native program execution is the only
 way for high speed simulation.
 .
 This package contains ghwdump, a simple command line tool to extract
 information from GHW files produced by GHDL and display it as text. It is
 mainly intended for use in debugging and is not needed for regular use of
 GHDL, where a wavefile visualization tool like gtkwave would normally be used.

Package: libghdl-4-1-0
Architecture: amd64 arm64 armel ppc64el ppc64
Built-Using: ${Built-Using-GCC}
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: VHDL compiler/simulator (shared library)
 GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
 GHDL is not an interpreter: it allows you to analyse and elaborate sources to
 generate machine code from your design. Native program execution is the only
 way for high speed simulation.
 .
 This package contains the shared library to access GHDL internals.

Package: libghdl-dev
Architecture: amd64 arm64 armel ppc64el ppc64
Built-Using: ${Built-Using-GCC}
Depends: libghdl-4-1-0 (= ${binary:Version}), ${misc:Depends}
Multi-Arch: same
Description: VHDL compiler/simulator (library development files)
 GHDL is a compiler and simulator for VHDL, a Hardware Description Language.
 GHDL is not an interpreter: it allows you to analyse and elaborate sources to
 generate machine code from your design. Native program execution is the only
 way for high speed simulation.
 .
 This package contains the files required to compile programs using libghdl.

=== debian/rules ===
#!/usr/bin/make -f

# Currently gcc can not be compiled with format-security and it is not needed
# for Ada code anyway
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,-format

#export DH_VERBOSE = 1

include /usr/share/dpkg/default.mk
include /usr/share/ada/packaging.mk

# These variables are used to find and unpack the gcc source
GCC_DIR := /usr/src/gcc-$(DEB_GNAT_VERSION)

# This variable is used in Makefile.in to adjust src/version.in
export GHDL_VER_DESC := $(DEB_VENDOR) $(DEB_VERSION)

# Get parallel option to parallelize the gcc build specifically (Ada builds
# are already parallelized by code included from debian_packaging-*.mk above).
MAKEPARALLEL = $(DEB_BUILD_OPTION_PARALLEL:%=-j%)

# Mcode is only supported on x86 architectures.
all_backends := gcc llvm $(and $(filter amd64 i386,$(DEB_HOST_ARCH_CPU)),mcode)

# build profile control over what backends get built
pkg.ghdl.no_profiles := $(filter pkg.ghdl.no%,$(DEB_BUILD_PROFILES))

# Built backends.
BACKENDS := $(filter-out $(pkg.ghdl.no_profiles:pkg.ghdl.no%=%),$(all_backends))

BUILDDIR := $(CURDIR)/builddir
TESTRUNDIR := $(CURDIR)/testrundir
STAMPSDIR := $(BUILDDIR)/stamps

# Common arguments for all calls to ./configure.
# The order is the same than there.
export CC           := gcc-$(DEB_GNAT_VERSION)
export CXX          := g++-$(DEB_GNAT_VERSION)
export CFLAGS
export CXXFLAGS
export GNATMAKE     := gnatmake $(GNATMAKEFLAGS)
export ADA_FLAGS    := $(ADAFLAGS)
export LDFLAGS

# Capture internal default arguments for the GCC internal compiler call so that
# it can be included in the configuration, as the ghdl driver for gcc does not
# include them otherwise.
export GCC_DEFAULT_OPTIONS := $(filter-out COLLECT_GCC_OPTIONS='-c' ,$(shell ${CC} -### -c test.c 2>&1 | grep COLLECT_GCC_OPTIONS | head -1))

# Used in 3 normal builds but not in the gcc part of the build section.
common_configure_arguments := \
  --prefix=/usr \
  --disable-werror \
  --incdir=lib/ghdl/include \
  --libnativedir=lib/$(DEB_HOST_MULTIARCH) \
  --enable-gplcompat \
 # EOL


%:
	dh ${@}

override_dh_clean:
	# An .orig file exists in the release, don't delete it to not create
	# spurious differences to the tarball/git.
	dh_clean -Xtestsuite/synth/synth14/top.vhdl.orig

override_dh_auto_clean:
	# dh_auto_clean complains about python-distutils and fails if it
	# doesn't see a Makefile, so override the default build system.
	dh_auto_clean --buildsystem=makefile

override_dh_installdocs:
	dh_installdocs -pghdl -pghdl-mcode -pghdl-llvm -pghdl-gcc --link-doc=ghdl-common
	dh_installdocs --remaining-packages

override_dh_auto_configure: $(foreach backend,$(BACKENDS),$(STAMPSDIR)/configure-$(backend))

override_dh_auto_build: $(foreach backend,$(BACKENDS),$(STAMPSDIR)/build-$(backend))

override_dh_auto_install: $(foreach backend,$(BACKENDS),$(STAMPSDIR)/install-$(backend))
	@echo
	@echo ------------------------------------------------------------
	@echo Common install final steps
	@echo ------------------------------------------------------------
	cd debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH) && ln -s libghdl-*.so libghdl.so
	$(RM) debian/tmp/usr/lib/ghdl/src/ieee2008/LICENSE

override_dh_dwz:
	# dwz currently has problems with some debug sections created by the
	# current LLVM compiler and would cause this step to fail.
	#dh_dwz -a -Nghdl-llvm
	# Furthermore it appears to have problems with something in
	# libghdlvpi.so and runs into assertions, so disable it altogether for
	# now.

override_dh_auto_test: $(foreach backend,$(BACKENDS),$(STAMPSDIR)/test-$(backend))

override_dh_gencontrol:
ifneq ($(filter gcc,$(BACKENDS)),)
	dh_gencontrol -- -VBuilt-Using-GCC="$(shell dpkg-query -f '$${Source} (= $${Version})' -W gcc-$(DEB_GNAT_VERSION)-source)"
else
	dh_gencontrol
endif



$(STAMPSDIR)/configure-mcode:
	dh_testdir
	mkdir -p $(BUILDDIR)/mcode $(STAMPSDIR)
	@echo
	@echo ------------------------------------------------------------
	@echo Configuring with mcode backend
	@echo ------------------------------------------------------------
	cd $(BUILDDIR)/mcode && \
	../../configure --srcdir=../.. $(common_configure_arguments) \
		--libdir=lib/ghdl/mcode \
		--libghdldir=lib/ghdl/mcode/vhdl
	touch $@

$(STAMPSDIR)/build-mcode: $(STAMPSDIR)/configure-mcode
	dh_testdir
	@echo
	@echo ------------------------------------------------------------
	@echo Building with mcode backend
	@echo ------------------------------------------------------------
	$(MAKE) -C $(BUILDDIR)/mcode
	touch $@

$(STAMPSDIR)/install-mcode: $(STAMPSDIR)/build-mcode
	dh_testdir
	@echo
	@echo ------------------------------------------------------------
	@echo Installing with mcode backend
	@echo ------------------------------------------------------------
	$(MAKE) -C $(BUILDDIR)/mcode install DESTDIR=../../debian/tmp
	@echo
	@echo ------------------------------------------------------------
	@echo Moving parts to required locations
	@echo ------------------------------------------------------------
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	$(RM) -r debian/tmp/usr/lib/ghdl/src
	mv debian/tmp/usr/lib/ghdl/mcode/vhdl/src debian/tmp/usr/lib/ghdl
	mv debian/tmp/usr/lib/ghdl/mcode/libghdl-*.so debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/
	mv debian/tmp/usr/lib/ghdl/mcode/libghdl.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/

$(STAMPSDIR)/test-mcode: $(STAMPSDIR)/build-mcode
	dh_testdir
	@echo
	@echo ------------------------------------------------------------
	@echo Run testsuite for mcode backend
	@echo ------------------------------------------------------------
	# With some paths patched for the Debian packaging, the tests will not
	# work right when run from the build directory. To keep it simple
	# install into a temporary location and tell the testsuite to find ghdl
	# there.
	$(MAKE) -C $(BUILDDIR)/mcode install DESTDIR=$(TESTRUNDIR)/mcode
	debian/tests/ghdl-tests buildtest mcode
	touch $@


$(STAMPSDIR)/configure-llvm:
	dh_testdir
	mkdir -p $(BUILDDIR)/llvm $(STAMPSDIR)
	@echo
	@echo ------------------------------------------------------------
	@echo Configuring with llvm backend
	@echo ------------------------------------------------------------
	cd $(BUILDDIR)/llvm && \
	../../configure --srcdir=../.. $(common_configure_arguments) \
		--libdir=lib/ghdl/llvm \
		--libghdldir=lib/ghdl/llvm/vhdl \
		--with-llvm-config
	touch $@

$(STAMPSDIR)/build-llvm: $(STAMPSDIR)/configure-llvm
	dh_testdir
	@echo
	@echo ------------------------------------------------------------
	@echo Building with llvm backend
	@echo ------------------------------------------------------------
	$(MAKE) -C $(BUILDDIR)/llvm
	touch $@

$(STAMPSDIR)/install-llvm: $(STAMPSDIR)/build-llvm
	dh_testdir
	@echo
	@echo ------------------------------------------------------------
	@echo Installing with llvm backend
	@echo ------------------------------------------------------------
	$(MAKE) -C $(BUILDDIR)/llvm install DESTDIR=../../debian/tmp
	@echo
	@echo ------------------------------------------------------------
	@echo Moving parts to required locations
	@echo ------------------------------------------------------------
	mkdir -p debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	$(RM) -r debian/tmp/usr/lib/ghdl/src
	mv debian/tmp/usr/lib/ghdl/llvm/vhdl/src debian/tmp/usr/lib/ghdl
	mv debian/tmp/usr/lib/ghdl/llvm/libghdl-*.so debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/
	mv debian/tmp/usr/lib/ghdl/llvm/libghdl.a debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/

$(STAMPSDIR)/test-llvm: $(STAMPSDIR)/build-llvm
	dh_testdir
	@echo
	@echo ------------------------------------------------------------
	@echo Run testsuite for llvm backend
	@echo ------------------------------------------------------------
	# With some paths patched for the Debian packaging, the tests will not
	# work right when run from the build directory. To keep it simple
	# install into a temporary location and tell the testsuite to find ghdl
	# there.
	$(MAKE) -C $(BUILDDIR)/llvm install DESTDIR=$(TESTRUNDIR)/llvm

## ghdl 5.0.1%2Bdfsg

=== testsuite/gna/issue2626/sim/Makefile ===
SRC += ../src/Example_Design/duplicator.vhd
SRC += ../src/Example_Design/hexifier.vhd
SRC += ../src/Example_Design/serializer.vhd
SRC += ../src/Example_Design/merginator.vhd
SRC += ../src/SDCard/sdcard_globals.vhd
SRC += ../src/SDCard/sdcard_cmd.vhd
SRC += ../src/Example_Design/sdcard_cmd_logger.vhd
SRC += ../src/SDCard/sdcard_dat.vhd
SRC += ../src/SDCard/sdcard_ctrl.vhd
SRC += ../src/SDCard/sdcard_wrapper.vhd
SRC += sdcard_sim.vhd
#SRC += tb_cmd.vhd
#SRC += tb_sdcard.vhd


#DUT ?= cmd
DUT ?= sdcard


TB = tb_$(DUT)
SRC += $(TB).vhd
WAVE = $(TB).ghw
SAVE = $(TB).gtkw

sim: $(SRC)
	ghdl -c --std=08 $(SRC) -r $(TB) $(GENERIC) --assert-level=error --wave=$(WAVE) --stop-time=200us

questa: $(SRC)
	vcom -2008 $(SRC)
	vsim $(TB)

show: $(WAVE)
	gtkwave $(WAVE) $(SAVE)

formal: $(DUT)_bmc/PASS
$(DUT)_bmc/PASS: $(DUT).sby $(DUT).psl $(DUT).vhd
	sby --yosys "yosys -m ghdl" -f $(DUT).sby

show_bmc:
	gtkwave $(DUT)_bmc/engine_0/trace.vcd $(DUT).gtkw

show_cover:
	gtkwave $(DUT)_cover/engine_0/trace.vcd $(DUT).gtkw

clean:
	rm -rf *.o
	rm -rf work-obj08.cf
	rm -rf $(TB)
	rm -rf $(WAVE)
	rm -rf $(DUT)_bmc
	rm -rf $(DUT)_cover

## ghdl 5.0.1+dfsg

=== doc/requirements.txt ===
-r ../pyGHDL/requirements.txt

sphinx ~= 8.2
python-dateutil ~= 2.9

# Sphinx Extenstions
autoapi ~= 2.0
myst-parser ~= 4.0
sphinx_autodoc_typehints ~= 3.1

# Theme
furo

# BuildTheDocs Extensions (mostly patched Sphinx extensions)
#btd.sphinx.autoprogram>=0.1.7.post1

=== testsuite/requirements.txt ===
-r ../pyGHDL/requirements.txt

# Test Runner
pytest ~= 8.3
pytest-cov ~= 6.0

# Coverage collection
Coverage ~= 7.6

=== pyGHDL/cli/requirements.txt ===
-r ../dom/requirements.txt

pyTooling[terminal] ~= 8.2

=== pyGHDL/dom/requirements.txt ===
-r ../libghdl/requirements.txt

pyVHDLModel ~= 0.31.0
#https://github.com/VHDL/pyVHDLModel/archive/dev.zip#pyVHDLModel

=== pyGHDL/libghdl/requirements.txt ===
pyTooling[terminal] ~= 8.2

=== src/verilog/Makefile ===
--- 
+++ 
@@ -1,7 +1,9 @@
 PNODES=../../scripts/pnodes.py
+PNODESRS=../../scripts/pnodesrs.py
 PNODES_ARGS=--field-file=verilog-nodes.adb.in --kind-file=verilog-nodes.ads --node-file=verilog-nodes.ads --template-file=verilog-nodes.adb.in --meta-basename=verilog-nodes_meta --kind-type=Nkind --kind-range-prefix=Nkinds_ --kind-prefix=N_ --node-type=Node
 
-all: verilog-nodes.adb verilog-nodes_meta.ads verilog-nodes_meta.adb
+all: verilog-nodes.adb verilog-nodes_meta.ads verilog-nodes_meta.adb \
+  nodes_def.rs
 
 verilog-nodes.adb: verilog-nodes.adb.in verilog-nodes.ads $(PNODES)
 	$(RM) -f $@
@@ -18,3 +20,7 @@
 	$(PNODES) $(PNODES_ARGS) --keep-order meta_body > $@
 	chmod a-w $@
 
+nodes_def.rs: $(PNODESRS) verilog-nodes.ads
+	$(RM) $@
+	$(PNODESRS) $(PNODES_ARGS) verilog-nodes > $@
+	chmod -w $@

=== src/vhdl/Makefile ===
#  Copyright (C) 2002 - 2015 Tristan Gingold
#
#  This program is free software: you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation, either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program.  If not, see <gnu.org/licenses>.

# Some files are automatically generated using pnodes.py
# This Makefile can be used to regenerate these files.  Generated files must
# be committed and distribued with the sources, so that users don't need to
# regenerate them (and don't need to have python installed).

PNODES=../../scripts/pnodes.py
PNODESPY=../../scripts/pnodespy.py
PNODESRS=../../scripts/pnodesrs.py
PYTHON=python3

DEPS=vhdl-nodes.ads vhdl-nodes.adb.in $(PNODES)

GEN_FILES=vhdl-nodes.adb \
  vhdl-nodes_meta.ads \
  vhdl-nodes_meta.adb \
  vhdl-elocations.adb \
  vhdl-elocations_meta.ads \
  vhdl-elocations_meta.adb \
  ../../pyGHDL/libghdl/vhdl/nodes.py \
  ../../pyGHDL/libghdl/vhdl/nodes_meta.py \
  ../../pyGHDL/libghdl/vhdl/tokens.py \
  ../../pyGHDL/libghdl/vhdl/elocations.py \
  ../../pyGHDL/libghdl/errorout.py \
  ../../pyGHDL/libghdl/std_names.py \
  ../errorout_def.rs \
  ../std_names.rs \
  nodes_def.rs

NODES_FLAGS=--node-file=vhdl-nodes.ads --field-file=vhdl-nodes.adb.in \
  --template-file=vhdl-nodes.adb.in --kind-file=vhdl-nodes.ads \
  --meta-basename=vhdl-nodes_meta

ELOCATIONS_FLAGS=--node-file=vhdl-elocations.ads \
  --field-file=vhdl-elocations.adb.in --kind-file=vhdl-nodes.ads \
  --template-file=vhdl-elocations.adb.in --meta-basename=vhdl-elocations_meta

all: $(GEN_FILES)

vhdl-nodes.adb: vhdl-nodes.adb.in $(DEPS)
	$(RM) $@
	$(PNODES) $(NODES_FLAGS) body > $@
	chmod -w $@

vhdl-nodes_meta.ads: vhdl-nodes_meta.ads.in $(DEPS)
	$(RM) $@
	$(PNODES) $(NODES_FLAGS) meta_specs > $@
	chmod -w $@

vhdl-nodes_meta.adb: vhdl-nodes_meta.adb.in $(DEPS)
	$(RM) $@
	$(PNODES) $(NODES_FLAGS) meta_body > $@
	chmod -w $@

vhdl-elocations.adb: vhdl-elocations.adb.in vhdl-elocations.ads $(DEPS)
	$(RM) $@
	$(PNODES) $(ELOCATIONS_FLAGS) body > $@
	chmod -w $@

vhdl-elocations_meta.ads: vhdl-elocations_meta.ads.in vhdl-elocations.ads $(DEPS)
	$(RM) $@
	$(PNODES) $(ELOCATIONS_FLAGS) meta_specs > $@
	chmod -w $@

vhdl-elocations_meta.adb: vhdl-elocations_meta.adb.in vhdl-elocations.ads $(DEPS)
	$(RM) $@
	$(PNODES) $(ELOCATIONS_FLAGS) meta_body > $@
	chmod -w $@

../../pyGHDL/libghdl/vhdl/nodes.py: $(DEPS) $(PNODESPY)
	$(RM) $@
	$(PNODESPY) $(NODES_FLAGS) libghdl-nodes > $@
	$(PYTHON) -m black $@
	chmod -w $@

../../pyGHDL/libghdl/vhdl/nodes_meta.py: $(DEPS) $(PNODESPY)
	$(RM) $@
	$(PNODESPY) $(NODES_FLAGS) libghdl-meta > $@
	$(PYTHON) -m black $@
	chmod -w $@

../../pyGHDL/libghdl/std_names.py: $(PNODESPY) ../std_names.ads
	$(RM) $@
	$(PNODESPY) $(NODES_FLAGS) libghdl-names > $@
	$(PYTHON) -m black $@
	chmod -w $@

../../pyGHDL/libghdl/vhdl/tokens.py: $(PNODESPY) vhdl-tokens.ads
	$(RM) $@
	$(PNODESPY) $(NODES_FLAGS) libghdl-tokens > $@
	$(PYTHON) -m black $@
	chmod -w $@

../../pyGHDL/libghdl/vhdl/elocations.py: $(PNODESPY) vhdl-elocations.ads
	$(RM) $@
	$(PNODESPY) $(ELOCATIONS_FLAGS) libghdl-elocs > $@
	$(PYTHON) -m black $@
	chmod -w $@

../../pyGHDL/libghdl/errorout.py: $(PNODESPY) ../errorout.ads
	$(RM) $@
	$(PNODESPY) $(NODES_FLAGS) libghdl-errorout > $@
	$(PYTHON) -m black $@
	chmod -w $@

../errorout_def.rs: $(PNODESRS) ../errorout.ads
	$(RM) $@
	$(PNODESRS) $(NODES_FLAGS) errorout > $@
	chmod -w $@

../std_names.rs: $(PNODESRS) ../std_names.ads
	$(RM) $@
	$(PNODESRS) $(NODES_FLAGS) std_names > $@
	chmod -w $@

nodes_def.rs: $(PNODESRS) vhdl-nodes.ads vhdl-nodes.adb.in
	$(RM) $@
	$(PNODESRS) $(NODES_FLAGS) vhdl-nodes > $@
	chmod -w $@

clean:
	$(RM) -f $(GEN_FILES)

=== src/ortho/llvm6/Makefile ===
ortho_srcdir=..
GNATFLAGS=-gnaty3befhkmr -gnata -gnatf -gnatwael
CXX=clang++
LLVM_CONFIG=llvm-config
GNATMAKE=gnatmake
SED=sed
BE=llvm6
LLVM_LDFLAGS=`$(LLVM_CONFIG) --ldflags --libs --system-libs`

all: $(ortho_exec)

$(ortho_exec): $(ortho_srcdir)/llvm6/ortho_llvm.ads force llvm-cbindings.o
	$(GNATMAKE) -o $@ -aI$(ortho_srcdir)/llvm6 -aI$(ortho_srcdir) \
	$(GNATFLAGS) ortho_code_main -bargs -E \
	-largs llvm-cbindings.o $(GNATLFLAGS) --LINK=$(CXX) \
	$(LLVM_LDFLAGS) $(LDFLAGS)

llvm-cbindings.o: $(ortho_srcdir)/llvm6/llvm-cbindings.cpp
	$(CXX) -c `$(LLVM_CONFIG) --cxxflags` $(CXXFLAGS) -o $@ $<

clean:
	$(RM) -f *.o *.ali ortho_code_main
	$(RM) b~*.ad? *~

distclean: clean


force:

.PHONY: force all clean

ORTHO_BASENAME=ortho_llvm
include $(ortho_srcdir)/Makefile.inc

=== testsuite/gna/issue283/Makefile ===
PWD=$(shell pwd)

# Adjust to your needs:
# ======================================================================================================================

# Path to the root folder of the simulation framework
SIM_FRAMEWORK_DIR = /home/kaolpr/simulation_framework

# Top VHDL entity
TOPLEVEL = foo

# Python test file name (without extension)
MODULE = example

# Waveform output file
WAVEFORM_OUTPUT = waveform.ghw

# (Typically) Not to be modified:
# ======================================================================================================================

UNISIM_DIR = $(SIM_FRAMEWORK_DIR)/lib/xilinx-vivado/unisim/v08/
VHDL_VERSION = 08

VHDL_SOURCES = $(shell pwd)/bar.vhd $(shell pwd)/uut.vhd

COCOTB = $(SIM_FRAMEWORK_DIR)/lib/cocotb
GHDL_BIN_DIR = $(SIM_FRAMEWORK_DIR)/lib/ghdl/build/bin/

SIM=ghdl
ANALYSE_ARGS =
ELABORATE_ARGS =
SIM_ARGS = --wave=$(WAVEFORM_OUTPUT) --ieee-asserts=disable

PYTHON_SIM_MODULES_PATH = $(SIM_FRAMEWORK_DIR)/lib/python_modules

include $(COCOTB)/makefiles/Makefile.inc
include $(COCOTB)/makefiles/Makefile.sim

=== testsuite/gna/issue382/Makefile ===
ANALYSE=ghdl -a
ELABORATE=ghdl -e
VPATH=.

OBJECTS= demo.o tb_demo.o

all: tb_demo

sim:
	./tb_demo --stop-time=15sec --wave=tb_demo.ghw
gsim:
	killall gtkwave; true
	./tb_demo --stop-time=300sec --wave=tb_demo.ghw
	gtkwave tb_demo.ghw tb_demo.gtk
                        
tb_demo: $(OBJECTS)
	$(ELABORATE) $@

%.o:  %.vhd
	$(ANALYSE) $<

clean:
	$(RM) *.o tb_demo e~tb_demoe.lst *~ work-obj93.cf

=== testsuite/gna/sr2676/Makefile ===
# project name
PROJECT=reset
# vhdl files
FILES = reset.vhdl reset_types.vhdl reset-rtl.vhdl
# testbench
SIMTOP = reset_testbench
SIMFILES = reset-test.vhdl
# Simu break condition
GHDL_SIM_OPT    = --assert-level=error --ieee-asserts=disable
#GHDL_SIM_OPT    = --stop-time=1ms
SIMDIR = sim

GHDL_CMD        = ghdl
GHDL_FLAGS      = --warn-no-vital-generic 
VIEW_CMD        = /usr/bin/gtkwave

ghdl-compile:
	mkdir -p $(SIMDIR)
	$(GHDL_CMD) -i $(GHDL_FLAGS) --workdir=$(SIMDIR) --work=work $(SIMFILES) $(FILES)
	$(GHDL_CMD) -m $(GHDL_FLAGS) --workdir=$(SIMDIR) --work=work $(SIMTOP)
	@mv $(SIMTOP) $(SIMDIR)/$(SIMTOP)

ghdl-run: ghdl-compile
	@$(SIMDIR)/$(SIMTOP) $(GHDL_SIM_OPT) --vcdgz=$(SIMDIR)/$(SIMTOP).vcdgz

ghdl-view: 
	gunzip --stdout $(SIMDIR)/$(SIMTOP).vcdgz | $(VIEW_CMD) --vcd &

ghdl-clean :

=== testsuite/vpi/vpi009/Makefile ===
# Makefile

# defaults
SIM ?= ghdl
TOPLEVEL_LANG ?= vhdl
#SIM_ARGS ?= --wave=sim.ghw
SIM_ARGS = --vpi-trace

VHDL_SOURCES += $(PWD)/deposit_bug.vhdl \

# TOPLEVEL is the name of the toplevel module in your Verilog or VHDL file
TOPLEVEL = deposit_bug

# MODULE is the basename of the Python test file
MODULE = test_deposit_bug

# include cocotb's make rules to take care of the simulator setup
include $(shell cocotb-config --makefiles)/Makefile.sim

=== debian/changelog ===
ghdl (5.0.1+dfsg-1ubuntu1) plucky; urgency=medium

  * Explicitly build using LLVM 19.
  * Build again on any arch.
  * Ignore LLVM backend test results for a first build on armhf and s390x.
  * Ignore GCC backend test results for a first build on armhf.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 30 Mar 2025 18:44:50 +0200

ghdl (5.0.1+dfsg-1) unstable; urgency=medium

  * New upstream version 5.0.1+dfsg
  * Update debian/copyright
  * Drop all backported patches
  * Update libghdl soname to current version
  * Use GCC/GNAT version 14 (Closes: 1092658, 1100461)
  * Create dummy gcc/vhdl/lang.opt.urls file to work with gcc-14
  * Bump Standards-Version to 4.7.2, no changes necessary

 -- Andreas Bombe <aeb@debian.org>  Fri, 28 Mar 2025 01:47:15 +0100

=== debian/control ===
--- 
+++ 
@@ -5,24 +5,24 @@
 Uploaders: Andreas Bombe <aeb@debian.org>
 Build-Depends: debhelper-compat (= 13),
                dh-ada-library (>= 8.1),
-               gnat-13, gcc-13, g++-13,
-               gcc-13-source <!pkg.ghdl.nogcc>,
-               libisl-dev (>= 0.14) <!pkg.ghdl.nogcc>,
+               gnat-14, gcc-14, g++-14,
+               gcc-14-source <!pkg.ghdl.nogcc>,
+               libisl-dev (>= 0.20) <!pkg.ghdl.nogcc>,
                libmpc-dev (>= 1.0) <!pkg.ghdl.nogcc>,
                libmpfr-dev (>= 3.0.0-9~) <!pkg.ghdl.nogcc>,
                libgmp-dev (>= 2:5.0.1~) <!pkg.ghdl.nogcc>,
                texinfo <!pkg.ghdl.nogcc>,
-               llvm-dev (<< 1:20~) <!pkg.ghdl.nollvm>,
-               clang (>= 1:3.5) <!pkg.ghdl.nollvm>,
+               llvm-19-dev <!pkg.ghdl.nollvm>,
+               clang-19 (>= 1:3.5) <!pkg.ghdl.nollvm>,
                zlib1g-dev
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Homepage: https://github.com/ghdl/ghdl
 Vcs-Browser: https://salsa.debian.org/electronics-team/ghdl/ghdl
 Vcs-Git: https://salsa.debian.org/electronics-team/ghdl/ghdl.git
 Rules-Requires-Root: no
 
 Package: ghdl
-Architecture: amd64 arm64 armel ppc64el ppc64
+Architecture: any
 Depends: ghdl-common (= ${binary:Version}),
          ghdl-mcode [amd64] <!pkg.ghdl.nomcode>
          | ghdl-gcc <!pkg.ghdl.nogcc>
@@ -53,7 +53,7 @@
  is installed.
 
 Package: ghdl-common
-Architecture: amd64 arm64 armel ppc64el ppc64
+Architecture: any
 Depends: ${misc:Depends}
 Breaks: ghdl (<< 0.37+dfsg2)
 Replaces: ghdl (<< 0.37+dfsg2)
@@ -66,7 +66,7 @@
  This package contains common files for the GHDL compiler packages.
 
 Package: ghdl-mcode
-Architecture: amd64
+Architecture: any-i386 any-amd64
 Build-Profiles: <!pkg.ghdl.nomcode>
 Depends: ghdl-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
 Description: VHDL compiler/simulator (mcode backend)
@@ -78,7 +78,7 @@
  This package contains the compiler with the mcode backend.
 
 Package: ghdl-gcc
-Architecture: amd64 arm64 armel ppc64el ppc64
+Architecture: any
 Build-Profiles: <!pkg.ghdl.nogcc>
 Built-Using: ${Built-Using-GCC}
 Depends: ghdl-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
@@ -92,7 +92,7 @@
  This package contains the compiler with the GCC backend.
 
 Package: ghdl-llvm
-Architecture: amd64 arm64 armel ppc64el ppc64
+Architecture: any
 Build-Profiles: <!pkg.ghdl.nollvm>
 Depends: ghdl-common (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends},
 	gcc, zlib1g-dev
@@ -105,7 +105,7 @@
  This package contains the compiler with the LLVM backend.
 
 Package: ghdl-tools
-Architecture: amd64 arm64 armel ppc64el ppc64
+Architecture: amd64 arm64 armel armhf ppc64el ppc64
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Breaks: gtkwave (<< 3.3.110~)
 Replaces: gtkwave (<< 3.3.110~)
@@ -120,8 +120,8 @@
  mainly intended for use in debugging and is not needed for regular use of
  GHDL, where a wavefile visualization tool like gtkwave would normally be used.
 
-Package: libghdl-4-1-0
-Architecture: amd64 arm64 armel ppc64el ppc64
+Package: libghdl-5-0-1
+Architecture: any
 Built-Using: ${Built-Using-GCC}
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Multi-Arch: same
@@ -134,9 +134,9 @@
  This package contains the shared library to access GHDL internals.
 
 Package: libghdl-dev
-Architecture: amd64 arm64 armel ppc64el ppc64
+Architecture: any
 Built-Using: ${Built-Using-GCC}
-Depends: libghdl-4-1-0 (= ${binary:Version}), ${misc:Depends}
+Depends: libghdl-5-0-1 (= ${binary:Version}), ${misc:Depends}
 Multi-Arch: same
 Description: VHDL compiler/simulator (library development files)
  GHDL is a compiler and simulator for VHDL, a Hardware Description Language.

=== debian/rules ===
--- 
+++ 
@@ -155,7 +155,13 @@
 	# install into a temporary location and tell the testsuite to find ghdl
 	# there.
 	$(MAKE) -C $(BUILDDIR)/mcode install DESTDIR=$(TESTRUNDIR)/mcode
-	debian/tests/ghdl-tests buildtest mcode
+	if debian/tests/ghdl-tests buildtest mcode; then \
+	  : ; \
+	elif [ -n "$(filter $(DEB_HOST_ARCH), none)" ]; then \
+	  echo "Ignoring test results for MCODE on $(DEB_HOST_ARCH)"; \
+	else \
+	  exit $$?; \
+	fi
 	touch $@
 
 
@@ -170,7 +176,7 @@
 	../../configure --srcdir=../.. $(common_configure_arguments) \
 		--libdir=lib/ghdl/llvm \
 		--libghdldir=lib/ghdl/llvm/vhdl \
-		--with-llvm-config
+		--with-llvm-config=llvm-config-19
 	touch $@
 
 $(STAMPSDIR)/build-llvm: $(STAMPSDIR)/configure-llvm
@@ -207,6 +213,3 @@
 	@echo ------------------------------------------------------------
 	# With some paths patched for the Debian packaging, the tests will not
 	# work right when run from the build directory. To keep it simple
-	# install into a temporary location and tell the testsuite to find ghdl
-	# there.
-	$(MAKE) -C $(BUILDDIR)/llvm install DESTDIR=$(TESTRUNDIR)/llvm

=== debian/tests/control ===
Test-Command: debian/tests/ghdl-tests autopkgtest gcc
Depends: ghdl-gcc, ghdl-tools
Restrictions: skip-not-installable, flaky

Test-Command: debian/tests/ghdl-tests autopkgtest llvm
Depends: ghdl-llvm, ghdl-tools
Restrictions: skip-not-installable, flaky

Test-Command: debian/tests/ghdl-tests autopkgtest mcode
Depends: ghdl-mcode, gcc, libc6-dev, ghdl-tools
Restrictions: skip-not-installable, flaky

=== debian/watch ===
version=4

opts="dversionmangle=auto,\
     uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha|a|b)\.?\d*)$/$1~$2/, \
     repacksuffix=+dfsg" \
https://github.com/ghdl/@PACKAGE@/tags \
(?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
